package com.ejie.ad74a.control;

import com.ejie.ad74a.service.DocuAvisosService;
import com.ejie.ad74a.util.comun.UtilWeb;
import com.ejie.ad74a.util.comun.Utilidades;
import com.ejie.ad74a.util.constantes.Constantes;
import com.ejie.ad74a.util.pid.Ad74aPIDws;
import com.ejie.ad74a.util.pif.Ad74aPIFws;
import com.ejie.x38.control.bind.annotation.RequestJsonBody;
import com.ejie.x38.dto.JerarquiaDto;
import com.ejie.x38.dto.TableRequestDto;
import com.ejie.x38.dto.TableResponseDto;
import com.ejie.x38.dto.TableRowDto;
import com.ejie.x38.util.DateTimeManager;

import v90.padoc.stub.W43DfDocument;

import java.io.IOException;
import java.io.InputStream;
import java.util.ArrayList;
import java.util.Date;
import java.util.List;
import java.util.Properties;

import javax.servlet.ServletException;
import javax.servlet.http.HttpServletRequest;
import javax.servlet.http.HttpServletResponse;
import javax.servlet.http.HttpSession;

import org.slf4j.Logger;
import org.slf4j.LoggerFactory;
import org.springframework.beans.factory.annotation.Autowired;
import org.springframework.beans.propertyeditors.CustomDateEditor;
import org.springframework.context.i18n.LocaleContextHolder;
import org.springframework.http.HttpStatus;
import org.springframework.http.MediaType;
import org.springframework.stereotype.Controller;
import org.springframework.transaction.annotation.Transactional;
import org.springframework.ui.Model;
import org.springframework.web.bind.ServletRequestDataBinder;
import org.springframework.web.bind.annotation.InitBinder;
import org.springframework.web.bind.annotation.ModelAttribute;
import org.springframework.web.bind.annotation.PathVariable;
import org.springframework.web.bind.annotation.RequestBody;
import org.springframework.web.bind.annotation.RequestMapping;
import org.springframework.web.bind.annotation.RequestMethod;
import org.springframework.web.bind.annotation.RequestParam;
import org.springframework.web.bind.annotation.ResponseBody;
import org.springframework.web.bind.annotation.ResponseStatus;
import org.springframework.web.multipart.support.ByteArrayMultipartFileEditor;

import com.ejie.ad74a.exceptions.Ad74aWebserviceException;
import com.ejie.ad74a.exceptions.ManagerErrors;
import com.ejie.ad74a.model.ConvivientesInfSoci;
import com.ejie.ad74a.model.DocuAvisos;

/**
 * DocuAvisosController generated by UDA, 13-jul-2023 10:09:34.
 * 
 * @author UDA
 */

@Controller
@RequestMapping(value = "/docuavisos")

public class DocuAvisosController {

	private static final Logger logger = LoggerFactory.getLogger(DocuAvisosController.class);

	@Autowired
	private DocuAvisosService docuAvisosService;

	@Autowired
	private Properties appConfiguration;

	@Autowired
	private Ad74aPIDws pidWS;

	@InitBinder
	protected void initBinder(HttpServletRequest request, ServletRequestDataBinder binder) throws ServletException {
		binder.registerCustomEditor(byte[].class, new ByteArrayMultipartFileEditor());
		binder.registerCustomEditor(Date.class,
				new CustomDateEditor(DateTimeManager.getDateTimeFormat(LocaleContextHolder.getLocale()), true));
	}

	/*
	 * OPERACIONES CRUD (Create, Read, Update, Delete)
	 * 
	 */

	/**
	 * Operacion CRUD Read. Devuelve el bean correspondiente al identificador
	 * indicado.
	 * 
	 * @param idDocAviso70 BigDecimal
	 * @return DocuAvisos Objeto correspondiente al identificador indicado.
	 */
	@RequestMapping(value = "/{idDocAviso70}", method = RequestMethod.GET)
	public @ResponseBody DocuAvisos get(@PathVariable Long idDocAviso70) {
		DocuAvisos docuAvisos = new DocuAvisos();
		docuAvisos.setIdDocAviso70(idDocAviso70);
		docuAvisos = this.docuAvisosService.find(docuAvisos);
		DocuAvisosController.logger.info("[GET - findBy_PK] : Obtener DocuAvisos por PK");
		return docuAvisos;
	}

	/**
	 * Devuelve una lista de beans correspondientes a los valores de filtrados
	 * indicados en el objeto pasado como parametro.
	 *
	 * @param filterDocuAvisos DocuAvisos Objeto que contiene los parametros de
	 *                         filtrado utilizados en la busqueda.
	 * @return List<DocuAvisos> Lista de objetos correspondientes a la busqueda
	 *         realizada.
	 */
	@RequestMapping(method = RequestMethod.GET)
	public @ResponseBody List<DocuAvisos> getAll(@ModelAttribute DocuAvisos filterDocuAvisos) {
		DocuAvisosController.logger.info("[GET - find_ALL] : Obtener DocuAvisos por filtro");
		return this.docuAvisosService.findAll(filterDocuAvisos, null);
	}

	/**
	 * Operacion CRUD Edit. Modificacion del bean indicado.
	 *
	 * @param docuAvisos DocuAvisos Bean que contiene la informacion a modificar.
	 * @return DocuAvisos Bean resultante de la modificacion.
	 */
	@RequestMapping(value = "/edit", method = RequestMethod.PUT)
	public @ResponseBody DocuAvisos edit(@RequestBody DocuAvisos docuAvisos) {
		DocuAvisos docuAvisosAux = this.docuAvisosService.update(docuAvisos);
		DocuAvisosController.logger.info("[PUT] : DocuAvisos actualizado correctamente");
		return docuAvisosAux;
	}

	/**
	 * Operacion CRUD Create. Creacion de un nuevo registro a partir del bean
	 * indicado.
	 *
	 * @param docuAvisos DocuAvisos Bean que contiene la informacion con la que se
	 *                   va a crear el nuevo registro.
	 * @return DocuAvisos Bean resultante del proceso de creacion.
	 */
	@RequestMapping(value = "/add", method = RequestMethod.POST)
	public @ResponseBody DocuAvisos add(@RequestBody DocuAvisos docuAvisos) {
		DocuAvisos docuAvisosAux = this.docuAvisosService.add(docuAvisos);
		DocuAvisosController.logger.info("[POST] : DocuAvisos insertado correctamente");
		return docuAvisosAux;
	}

	/**
	 * Operacion CRUD Delete. Borrado del registro correspondiente al identificador
	 * especificado.
	 *
	 * @param idDocAviso70 BigDecimal Identificador del objeto que se desea
	 *                     eliminar.
	 * @return DocuAvisos Bean eliminado.
	 */
	@RequestMapping(value = "/{idDocAviso70}", method = RequestMethod.DELETE)
	@ResponseStatus(value = HttpStatus.OK)
	public @ResponseBody DocuAvisos remove(@PathVariable Long idDocAviso70) {
		DocuAvisos docuAvisos = new DocuAvisos();
		docuAvisos.setIdDocAviso70(idDocAviso70);
		this.docuAvisosService.remove(docuAvisos);
		DocuAvisosController.logger.info("[DELETE] : DocuAvisos borrado correctamente");
		return docuAvisos;
	}

	/*
	 * METODOS COMPONENTE RUP_TABLE
	 * 
	 */

	/**
	 * Metodo de presentacion del RUP_TABLE.
	 * 
	 * @param model Model
	 * @return String
	 */
	@RequestMapping(value = "/maint", method = RequestMethod.GET)
	public String getFormEdit(Model model) {
		DocuAvisosController.logger.info("[GET - View] : docuavisos");
		model.addAttribute("docuavisos", new DocuAvisos());
		return "docuavisos";
	}

	/**
	 * Operacion de filtrado del componente RUP_TABLE.
	 * 
	 * @param filterDocuAvisos DocuAvisos Bean que contiene los parametros de
	 *                         filtrado a emplear.
	 * @param tableRequestDto  Dto que contiene los parametros de configuracion
	 *                         propios del RUP_TABLE a aplicar en el filtrado.
	 * @return TableResponseDto<DocuAvisos> Dto que contiene el resultado del
	 *         filtrado realizado por el componente RUP_TABLE.
	 */
	@RequestMapping(value = "/filter", method = RequestMethod.POST)
	public @ResponseBody TableResponseDto<DocuAvisos> filter(
			@RequestJsonBody(param = "filter") DocuAvisos filterDocuAvisos,
			@RequestJsonBody TableRequestDto tableRequestDto) {
		DocuAvisosController.logger.info("[POST - filter] : Obtener DocuAvisoss");
		return this.docuAvisosService.filter(filterDocuAvisos, tableRequestDto, false);
	}

	@RequestMapping(value = "/{idAviso20}/filter", method = RequestMethod.POST)
	public @ResponseBody TableResponseDto<DocuAvisos> filterConAviso(
			@RequestJsonBody(param = "filter") DocuAvisos filterDocuAvisos,
			@RequestJsonBody TableRequestDto tableRequestDto, @PathVariable Long idAviso20,
			HttpServletRequest request) {
		if (idAviso20 != null && idAviso20.compareTo(0L) == 0) {
			HttpSession sesion = request.getSession();
			List<DocuAvisos> DocuAvisos = new ArrayList<DocuAvisos>();
			if (sesion.getAttribute(Constantes.VARCONTEXTO_DOCUAVISOS) != null) {
				DocuAvisos = (List<DocuAvisos>) sesion.getAttribute(Constantes.VARCONTEXTO_DOCUAVISOS);
			}
			Long recordNum = Long.valueOf(DocuAvisos.size());
			TableResponseDto<DocuAvisos> tableResponseDto = new TableResponseDto<DocuAvisos>(tableRequestDto, recordNum,
					DocuAvisos);
			return tableResponseDto;
		} else {
			DocuAvisos docuAvisos = new DocuAvisos();
			docuAvisos.setIdAviso70(idAviso20);
			DocuAvisosController.logger.info("[POST - filter] : Obtener DocuAvisoss");
			return this.docuAvisosService.filter(docuAvisos, tableRequestDto, false);
		}

	}

	@RequestMapping(value = "/clear", method = RequestMethod.GET)
	public @ResponseBody List<DocuAvisos> clearSession(HttpServletRequest request) {
		DocuAvisosController.logger.info("[GET - View] : clear session");
		HttpSession sesion = request.getSession();
		sesion.setAttribute(Constantes.VARCONTEXTO_DOCUAVISOS, new ArrayList<DocuAvisos>());

		return new ArrayList<DocuAvisos>();

	}

	/**
	 * Operacion de busqueda del componente RUP_TABLE.
	 * 
	 * @param filterDocuAvisos DocuAvisos Bean que contiene los parametros de
	 *                         filtrado a emplear.
	 * @param searchDocuAvisos DocuAvisos Bean que contiene los parametros de
	 *                         busqueda a emplear.
	 * @param tableRequestDto  Dto que contiene los parametros de configuracion
	 *                         propios del RUP_TABLE a aplicar en la búsqueda.
	 * @return TableRowDto<DocuAvisos> Dto que contiene el resultado de la busqueda
	 *         realizada por el componente RUP_TABLE.
	 */
	@RequestMapping(value = "/search", method = RequestMethod.POST)
	public @ResponseBody List<TableRowDto<DocuAvisos>> search(
			@RequestJsonBody(param = "filter") DocuAvisos filterDocuAvisos,
			@RequestJsonBody(param = "search") DocuAvisos searchDocuAvisos,
			@RequestJsonBody TableRequestDto tableRequestDto) {
		DocuAvisosController.logger.info("[POST - search] : Buscar DocuAvisoss");
		return this.docuAvisosService.search(filterDocuAvisos, searchDocuAvisos, tableRequestDto, false);
	}

	/**
	 * Borrado multiple de registros
	 * 
	 * @param filterDocuAvisos DocuAvisos Bean que contiene los parametros de
	 *                         filtrado a emplear.
	 * @param tableRequestDto  Dto que contiene los parametros de configuracion
	 *                         propios del RUP_TABLE a aplicar en la busqueda.
	 * @return List<String> Lista de los identificadores de los registros
	 *         eliminados.
	 * 
	 */
	@RequestMapping(value = "/deleteAll", method = RequestMethod.POST)
	@ResponseStatus(value = HttpStatus.OK)
	public @ResponseBody List<String> removeMultiple(@RequestJsonBody TableRequestDto tableRequestDto) {
		DocuAvisosController.logger.info("[POST - removeMultiple] : Eliminar multiples DocuAvisoss");
		this.docuAvisosService.removeMultiple(tableRequestDto);
		DocuAvisosController.logger.info("All entities correctly deleted!");

		return tableRequestDto.getMultiselection().getSelectedIds();
	}

	/*
	 * METODOS COMPONENTE RUP_TABLE - JERARQUIA
	 */

	/**
	 * Operacion de filtrado del componente RUP_TABLE para presentar los registros
	 * mediante visualizacion jerarquica.
	 * 
	 * @param filterDocuAvisos DocuAvisos Bean que contiene los parametros de
	 *                         filtrado a emplear.
	 * @param tableRequestDto  Dto que contiene los parametros de configuracion
	 *                         propios del RUP_TABLE a aplicar en el filtrado.
	 * @return TableResponseDto<JerarquiaDto<DocuAvisos>> Dto que contiene el
	 *         resultado del filtrado realizado por el componente RUP_TABLE.
	 */
	@RequestMapping(value = "/jerarquia/filter", method = RequestMethod.POST)
	public @ResponseBody TableResponseDto<JerarquiaDto<DocuAvisos>> jerarquia(
			@RequestJsonBody(param = "filter") DocuAvisos filterDocuAvisos,
			@RequestJsonBody TableRequestDto tableRequestDto) {
		DocuAvisosController.logger.info("[POST - jerarquia] : Obtener DocuAvisoss jerarquia");
		return this.docuAvisosService.jerarquia(filterDocuAvisos, tableRequestDto, false);
	}

	/**
	 * Recupera los hijos de los registros desplegados en la visualizacion
	 * jerarquica.
	 * 
	 * @param filterDocuAvisos DocuAvisos Bean que contiene los parametros de
	 *                         filtrado a emplear.
	 * @param tableRequestDto  Dto que contiene los parametros de configuracion
	 *                         propios del RUP_TABLE a aplicar en el filtrado.
	 * @return TableResponseDto<JerarquiaDto<DocuAvisos>> Dto que contiene el
	 *         resultado del filtrado realizado por el componente RUP_TABLE.
	 */
	@RequestMapping(value = "/jerarquiaChildren", method = RequestMethod.POST)
	public @ResponseBody TableResponseDto<JerarquiaDto<DocuAvisos>> jerarquiaChildren(
			@RequestJsonBody(param = "filter") DocuAvisos filterDocuAvisos,
			@RequestJsonBody TableRequestDto tableRequestDto) {
		DocuAvisosController.logger.info("[POST - jerarquia] : Obtener DocuAvisoss jerarquia - Hijos");
		return this.docuAvisosService.jerarquiaChildren(filterDocuAvisos, tableRequestDto);
	}

	/**
	 * EXPORTERS
	 */
	/**
	 * Devuelve los datos exportados de la tabla y los copia al Portapapeles.
	 *
	 * @param filterDocuAvisos DocuAvisos
	 * @param tableRequestDto  TableRequestDto
	 */
	@RequestMapping(value = "/clipboardReport", method = RequestMethod.POST)
	protected @ResponseBody List<DocuAvisos> getClipboardReport(
			@RequestJsonBody(param = "filter") DocuAvisos filterDocuAvisos,
			@RequestJsonBody TableRequestDto tableRequestDto) {
		DocuAvisosController.logger.info("[POST - clipboardReport] : : Copiar en Portapapeles");
		return this.docuAvisosService.getMultiple(filterDocuAvisos, tableRequestDto, false);
	}

	/**
	 * Devuelve un fichero excel que contiene los datos exportados de la tabla.
	 *
	 * @param filter          DocuAvisos
	 * @param columns         String[]
	 * @param fileName        String
	 * @param sheetTitle      String
	 * @param tableRequestDto TableRequestDto
	 * @param request         HttpServletRequest
	 * @param response        HttpServletResponse
	 */
	@RequestMapping(value = { "/xlsReport",
			"/xlsxReport" }, method = RequestMethod.POST, produces = MediaType.APPLICATION_OCTET_STREAM_VALUE)
	protected @ResponseBody void generateExcelReport(
			@RequestJsonBody(param = "filter", required = false) DocuAvisos filter,
			@RequestJsonBody(param = "columns", required = false) String[] columns,
			@RequestJsonBody(param = "columnsName", required = false) String[] columnsName,
			@RequestJsonBody(param = "fileName", required = false) String fileName,
			@RequestJsonBody(param = "sheetTitle", required = false) String sheetTitle,
			@RequestJsonBody TableRequestDto tableRequestDto, HttpServletRequest request, HttpServletResponse response)
			throws ServletException {
		DocuAvisosController.logger.info("[POST - generateExcelReport] : Devuelve un fichero excel");

		this.docuAvisosService.generateReport(filter, columns, columnsName, fileName, sheetTitle, tableRequestDto,
				request, response);
	}

	/**
	 * Devuelve un fichero pdf que contiene los datos exportados de la tabla.
	 *
	 * @param filter          DocuAvisos
	 * @param columns         String[]
	 * @param fileName        String
	 * @param sheetTitle      String
	 * @param tableRequestDto TableRequestDto
	 * @param request         HttpServletRequest
	 * @param response        HttpServletResponse
	 */
	@RequestMapping(value = "pdfReport", method = RequestMethod.POST, produces = MediaType.APPLICATION_OCTET_STREAM_VALUE)
	protected @ResponseBody void generatePDFReport(
			@RequestJsonBody(param = "filter", required = false) DocuAvisos filter,
			@RequestJsonBody(param = "columns", required = false) String[] columns,
			@RequestJsonBody(param = "columnsName", required = false) String[] columnsName,
			@RequestJsonBody(param = "fileName", required = false) String fileName,
			@RequestJsonBody(param = "sheetTitle", required = false) String sheetTitle,
			@RequestJsonBody TableRequestDto tableRequestDto, HttpServletRequest request,
			HttpServletResponse response) {
		DocuAvisosController.logger.info("[POST - generatePDFReport] : Devuelve un fichero pdf");

		this.docuAvisosService.generateReport(filter, columns, columnsName, fileName, sheetTitle, tableRequestDto,
				request, response);
	}

	/**
	 * Devuelve un fichero ods que contiene los datos exportados de la tabla.
	 *
	 * @param filter          DocuAvisos
	 * @param columns         String[]
	 * @param fileName        String
	 * @param sheetTitle      String
	 * @param tableRequestDto TableRequestDto
	 * @param request         HttpServletRequest
	 * @param response        HttpServletResponse
	 */
	@RequestMapping(value = "odsReport", method = RequestMethod.POST, produces = MediaType.APPLICATION_OCTET_STREAM_VALUE)
	protected @ResponseBody void generateODSReport(
			@RequestJsonBody(param = "filter", required = false) DocuAvisos filter,
			@RequestJsonBody(param = "columns", required = false) String[] columns,
			@RequestJsonBody(param = "columnsName", required = false) String[] columnsName,
			@RequestJsonBody(param = "fileName", required = false) String fileName,
			@RequestJsonBody(param = "sheetTitle", required = false) String sheetTitle,
			@RequestJsonBody TableRequestDto tableRequestDto, HttpServletRequest request,
			HttpServletResponse response) {
		DocuAvisosController.logger.info("[POST - generateODSReport] : Devuelve un fichero ods");

		this.docuAvisosService.generateReport(filter, columns, columnsName, fileName, sheetTitle, tableRequestDto,
				request, response);
	}

	/**
	 * Devuelve un fichero csv que contiene los datos exportados de la tabla.
	 *
	 * @param filter          DocuAvisos
	 * @param columns         String[]
	 * @param fileName        String
	 * @param sheetTitle      String
	 * @param tableRequestDto TableRequestDto
	 * @param request         HttpServletRequest
	 * @param response        HttpServletResponse
	 */
	@RequestMapping(value = "csvReport", method = RequestMethod.POST, produces = MediaType.APPLICATION_OCTET_STREAM_VALUE)
	protected @ResponseBody void generateCSVReport(
			@RequestJsonBody(param = "filter", required = false) DocuAvisos filter,
			@RequestJsonBody(param = "columns", required = false) String[] columns,
			@RequestJsonBody(param = "columnsName", required = false) String[] columnsName,
			@RequestJsonBody(param = "fileName", required = false) String fileName,
			@RequestJsonBody(param = "sheetTitle", required = false) String sheetTitle,
			@RequestJsonBody TableRequestDto tableRequestDto, HttpServletRequest request,
			HttpServletResponse response) {
		DocuAvisosController.logger.info("[POST - generateCSVReport] : Devuelve un fichero csv");

		this.docuAvisosService.generateReport(filter, columns, columnsName, fileName, sheetTitle, tableRequestDto,
				request, response);
	}

	@RequestMapping(value = "/downloadDocuAviso/{oid}", method = RequestMethod.GET)
	public void downloadDocument(@PathVariable String oid, @RequestParam(required = true) String nombreDoc,
			HttpServletResponse response) throws IOException, Ad74aWebserviceException {

		String rutaPif = "";
		if (!Utilidades.esBlancoNulo(oid)) {
			try {

				rutaPif = this.appConfiguration.getProperty("webservice.dokusi.pif.dir");
				W43DfDocument docPid = pidWS.get(oid, rutaPif);
				rutaPif = docPid.getContent().getPath();
				DocuAvisosController.logger.info(
						"DocuAvisosController.downloadDocument - Ad74aPIFws.getInstance().downloadDocument path = {}",
						rutaPif);
				InputStream inputStream = Ad74aPIFws.getInstance().downloadDocument(rutaPif);
				UtilWeb.downloadFile(nombreDoc, docPid.getContent().getFormat().getMimeType(), 0, inputStream, response,
						"");
			} catch (Exception e) {
				ManagerErrors.manageException(e, "Error al descargar el documento");
			} finally {
				Ad74aPIFws.getInstance().deleteDocument(rutaPif);
			}
		}

	}

	@Transactional(rollbackFor = Throwable.class)
	@RequestMapping(value = "/deleteDocuAviso/{oid}", method = RequestMethod.DELETE)
	public void deleteDocuAviso(@PathVariable String oid, HttpServletResponse response, HttpServletRequest request)
			throws IOException, Ad74aWebserviceException {

		if (!Utilidades.esBlancoNulo(oid)) {
			try {
				this.docuAvisosService.removeByRuta(oid);
				this.pidWS.delete(oid);
			} catch (Exception e) {
				ManagerErrors.manageException(e, "Error al eliminar el documento");
			}
			HttpSession sesion = request.getSession();
			List<DocuAvisos> docuAvisosList = new ArrayList<DocuAvisos>();
			if (sesion.getAttribute(Constantes.VARCONTEXTO_DOCUAVISOS) != null) {
				docuAvisosList = (List<DocuAvisos>) sesion.getAttribute(Constantes.VARCONTEXTO_DOCUAVISOS);
			}
			for (int i = 0; i < docuAvisosList.size(); i++) {
				if (docuAvisosList.get(i).getRuta70().equals(oid)) {
					docuAvisosList.remove(i);
				}
			}
		}

	}

}
